function $(id)
{
  return document.getElementById(id);
}

function contains(array, element)
{
  for(i in array) if(element == array[i]) return true;
  return false;
}

function randInt(n)
{
  return Math.floor(Math.random()*n);
}

var nesting = 0;
var debug_text = "";

function debug(s)
{
  if(!$("debugging").checked) return;
  
  nesting++;
  if(typeof(s) != "object") debug_text += s + "<br>";
  else for(var i in s) debug(s[i]);
  nesting--;
  if(nesting==0)
  {
    $("debug").innerHTML += debug_text + "<hr>";
    debug_text = "";
  }
}

function enabled(expansion)
{
  return $("enable_" + expansion).checked;
}

var lastcard;

function showCard(card, keeplast)
{
  if(!keeplast) $("card").innerHTML = "";
  $("card").innerHTML += "<img src='cards/" + card +
                         "' width='320' height='500'> ";
  if(card == lastcard) $("card").innerHTML += "(Yes, again)";
  lastcard = card;
}

function buildUI()
{
  for(var i in expansions)
  {
    var checkbox = "<input type='checkbox' id='enable_" + expansions[i] + "'";
    if(expansions[i] == "Arkham") checkbox += " checked disabled=1";
    $("expansions").innerHTML += checkbox + ">" + expansions[i] + "<br>";
  }
}

var neighborhoods = {}
var gate_cards    = [];

function shuffleGateDeck()
{
  for(var i=0; i<gate_cards.length; i++)
  {
    var other = randInt(gate_cards.length);
    var temp = gate_cards[i];
    gate_cards[i] = gate_cards[other];
    gate_cards[other] = temp;
  }
  debug("shuffle result:");
  debug(gate_cards);
}
 
function drawLocation(location)
{
  var cards = neighborhoods[location];
  var n = $("drawtwo").checked ? 2 : 1;
  
  for(var i=0; i<n; i++)
  {
    var card;
    do card = cards[randInt(cards.length)];
    while(i==1 && card == lastcard);
    debug(card);
    showCard(card, i);
  }
}

function drawGate(colors)
{ 
  var card;
  var shuffled = false;
  var fails = 0;
  debug(colors);

  var n = $("drawtwo").checked ? 2 : 1;  
  for(var i=0; i<n; i++)
  {
    do
    {    
      card = gate_cards.shift();
      debug(card);
      gate_cards.push(card);
      if(card[0] == "shuffle")
      {
        shuffleGateDeck();
        shuffled = true;
      }
      if(fails++ == 20)
      {
        $("card").innerHTML = "Bad luck or broken code; couldn't find your " +
          "card in 20 attempts. Try again if feeling lucky.<p>" +
          $("card").innerHTML;
        return;
      }
    } while(card[1] != "wild" && !contains(colors, card[1]));
    showCard(card[0], i);
  }

  if(shuffled) $("card").innerHTML =
    "(Shuffled gate deck)<p>" + $("card").innerHTML;
}

function shuffle()
{
  $("card").innerHTML = "";
  
  // build neighborhood decks/interface
  neighborhoods = {};
  
  $("locations").innerHTML =
    "<input type='checkbox' name='drawtwo' id='drawtwo'> Draw two encounters";
  for(var i in expansions)
  {
    var exp = expansions[i];      
    if(enabled(exp))
    {
      var first = true;
      for(var j in neighborhood_encounters[exp])
      {
        if(first)
        {
          first = false;
          $("locations").innerHTML += "<h3>" + exp + "</h3>";
        }
        $("locations").innerHTML += "<a href='#' onclick=\"drawLocation('" +
                                    j + "');\">" + j + "</a><br>";

        var ne = neighborhood_encounters[exp][j];
        neighborhoods[j] = [];
        for(var k in ne)
        {
          if(enabled(k))
            for(var l in ne[k])
            {
              var card = ne[k][l];
              neighborhoods[j].push(card);
            }
        }
        debug(neighborhoods[j]);
      }
    }
  }

  // build gate deck
  gate_cards = [["shuffle", 0]];
  for(var i in gate_encounters)
  {
    if(enabled(i))
      for(var j in gate_encounters[i])
      {
        color = gate_colors[j];
        for(var k in gate_encounters[i][j])
          gate_cards.push([gate_encounters[i][j][k], color]);
      }
  }
  
  debug(gate_cards);
  shuffleGateDeck();
  
  $("locations").innerHTML += "<h3>Other Worlds</h3>";

  // build gate interface
  for(var i in other_worlds)
  {
    if(enabled(i))
      for(var j in other_worlds[i])
      {
        var link = "<a href='#' onclick=\"drawGate([";
        for(var k=1; k<5; k++)
          if(other_worlds[i][j][k])
            link +=  "'" + gate_colors[k-1] + "',";
        $("locations").innerHTML
          += link += "]);\">" + other_worlds[i][j][0] + "</a><br>";
      }
  }
}